=== debian/changelog ===
fltk1.3 (1.3.2-4) unstable; urgency=medium

  * debian/*.symbols*:
    - Update for current GCC version range -- fold in assumptions of
      having at least version 4.6.x (already true as of wheezy), and mark
      symbols specific to builds with version 4.8.x as optional.
    - Move more symbols (mostly destructor variants) Clang 3.3 doesn't
      emit into libfltk*1.3.symbols.no-clang; tag them as optional.
  * src/Fl_x.cxx (Fl_X::make_xid): Use Fl_Window::fullscreen_active rather
    than relying on a flag value Clang now (rightly) marks as inaccessible.
  * Standards-Version: 3.9.5 (already compliant).

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 19 Jan 2014 17:53:57 -0500

fltk1.3 (1.3.2-3) unstable; urgency=low

  * fltk-config.in: Fix --ldflags output to reinstate -lX11 (to account for
    potential calls to XCreatePixmap via the fl_create_offscreen macro) and to
    omit the explicit -L flag, as the script's automatic filtering of standard
    directories doesn't account for multiarch paths.  (Closes: #713933.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 27 Jun 2013 21:47:17 -0400

fltk1.3 (1.3.2-2) unstable; urgency=low

  * debian/rules: Preserve pregenerated upstream fltk.spec around calls to
    dh_auto_clean and dh_auto_configure to simplify version control.
  * Standards-Version: 3.9.4 (already compliant, modulo Doxygen bug #630982).
  * Retarget unstable now that Wheezy is out.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 07 May 2013 22:33:07 -0400

fltk1.3 (1.3.2-1) experimental; urgency=low

  * New upstream release.
  * debian/libfltk1.3.symbols: Update accordingly.
  * Merge Gecko DnD fix from 1.3.0-9, detailed below.  (Closes: #699860.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 21 Feb 2013 23:16:15 -0500

fltk1.3 (1.3.1-1) experimental; urgency=low

  * New upstream release; uploading to experimental per Wheezy freeze.
  * debian/libfltk1.3.symbols: Update accordingly.
  * debian/copyright: Update years, both for FLTK proper and for the
    (unused) convenience copy of libpng.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 12 Nov 2012 14:30:21 -0500

fltk1.3 (1.3.0-9) unstable; urgency=low

  * src/Fl_x.cxx: fix drag and drop of selections from Mozilla Gecko apps
    (iceape/icedove/iceweasel in Debian).  (Closes: #699860.)
  * debian/libfltk1.3.symbols: account for the new symbol that fix added.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 21 Feb 2013 22:54:48 -0500

fltk1.3 (1.3.0-8) unstable; urgency=medium

  * debian/rules:
    - Keep hardening flags out of the installed fltk-config by adding an
      extra configure run with them disabled and using the resulting
      fltk-config.  (Closes: #677705.)
    - Explicitly use hardened CPPFLAGS.
  * .gitignore: add fltk-config.unhardened.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 18 Jun 2012 21:43:53 -0400

fltk1.3 (1.3.0-7) unstable; urgency=low

  * {cairo,src}/Makefile: substitute -fPIC for -fPIE in C(XX)FLAGS.
  * debian/rules:
    - Enable full hardening.
    - Pass hardened LDFLAGS to configure as DSOFLAGS too.  (Closes: #663276.)
  * debian/source/options: rename to (git-only) local-options, so any
    source patches from NMUs will wind up in separate files.
  * test/Makefile: link the threads demo with LDFLAGS, not CXXFLAGS!

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 15 Mar 2012 21:48:05 -0400

fltk1.3 (1.3.0-6) unstable; urgency=low

  * debian/control:
    - Wrap and sort (build) dependencies.
    - Substitute libpng-dev for libpng12(-0)-dev.  (Closes: #662329.)
    - Drop ancient version on libfltk1.3-dev's libxft-dev suggestion.
    - Require debhelper (>= 9), which has been final for some time.
    - Standards-Version: 3.9.3.  (No changes needed.)
  * debian/copyright: update to copyright-format 1.0.
  * debian/libfltk1.3-dev.install: sort as well.
  * debian/libfltk1.3.symbols(.gcc46): split symbols clang 3.0 doesn't emit
    into a .no-clang file, and make them optional.
  * debian/libfltk1.3-{forms,gl,images}.symbols: likewise make
    .symbols.gcc46 contents optional everywhere.  (The lists exactly match.)
  * src/Fl_x.cxx: apply upstream's clang compatibility patch (r9192, per
    http://www.fltk.org/str.php?L2779).

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 07 Mar 2012 23:23:33 -0500
