=== debian/control ===
Source: fltk1.3
Section: libs
Priority: optional
Maintainer: Aaron M. Ucko <ucko@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.15.7),
               g++ (>= 4:4.6),
               imagemagick,
               libasound2-dev [linux-any],
               libcairo2-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libjpeg-dev,
               libpng-dev,
               libx11-dev,
               libxext-dev,
               libxft-dev,
               libxinerama-dev,
               pkg-config,
               zlib1g-dev | libz-dev
Build-Depends-Indep: doxygen-latex, texlive-font-utils
Standards-Version: 3.9.5
Homepage: http://www.fltk.org/
Vcs-Git: git://git.debian.org/users/ucko/fltk1.3.git
Vcs-Browser: http://git.debian.org/?p=users/ucko/fltk1.3.git;a=summary

Package: fluid
Section: devel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: fltk1.3-doc, libfltk1.3-dev
Multi-Arch: foreign
Description: Fast Light Toolkit - user interface designer
 This package provides Fluid, an interactive GUI designer for FLTK,
 allowing graphical development of FLTK-based user
 interfaces. It natively works with (textual) .fl files, but also
 includes rough support for reading .fd files produced by fdesign (in
 libforms-bin).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-dev
Section: libdevel
Architecture: any
Depends: libfltk-cairo1.3 (= ${binary:Version}),
         libfltk-forms1.3 (= ${binary:Version}),
         libfltk-gl1.3 (= ${binary:Version}),
         libfltk-images1.3 (= ${binary:Version}),
         libfltk1.3 (= ${binary:Version}),
         libx11-dev,
         ${misc:Depends}
Recommends: fluid, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev
Suggests: fltk1.3-doc,
          libcairo2-dev,
          libjpeg-dev,
          libpng-dev,
          libxext-dev,
          libxft-dev,
          libxinerama-dev,
          zlib1g-dev | libz-dev
Provides: libfltk-dev
Conflicts: libfltk-dev
Replaces: libfltk-dev
Description: Fast Light Toolkit - development files
 This package provides the files necessary for compiling programs
 that depend on FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-compat-headers
Section: libdevel
Architecture: all
Depends: libfltk1.3-dev, ${misc:Depends}
Multi-Arch: foreign
Description: Fast Light Toolkit - compatibility header symlinks
 This package provides header symlinks with .h rather than .H extensions for
 compatibility with some older code that relies on the lowercase-h names.

Package: libfltk1.3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Fast Light Toolkit - main shared library
 This package contains the files necessary for running programs
 dynamically linked with FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-cairo1.3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfltk1.3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Fast Light Toolkit - Cairo rendering layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Cairo rendering layer bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-forms1.3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfltk1.3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Fast Light Toolkit - Forms compatibility layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Forms compatibility layer.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-gl1.3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfltk1.3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Fast Light Toolkit - OpenGL rendering support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's OpenGL rendering bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-images1.3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfltk1.3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Fast Light Toolkit - image loading support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's bindings to image-loading libraries.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libfltk1.3 (= ${binary:Version}), ${misc:Depends}
Recommends: gdb
Description: Fast Light Toolkit - shared libraries with debugging symbols
 This package is useful to provide a backtrace with symbol names in a
 debugger; this facilitates interpretation of core dumps, and aids in finding
 logic errors in programs using the libraries (or in the libraries themselves).
 .
 Non-programmers will likely have little use for this.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Fast Light Toolkit - documentation
 This package provides documentation for FLTK, including a chapter on
 its user interface designer (fluid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-games
Section: games
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: fltk1.1-games
Replaces: fltk1.1-games
Multi-Arch: foreign
Description: Fast Light Toolkit - example games: checkers, sudoku
 This package contains the example games that accompany FLTK.
 Specifically, it contains the following two programs:
  - flblocks:   clear groups of adjacent blocks before they fill the screen;
  - flcheckers: classic board game, also known as draughts;
  - flsudoku:   Sudoku puzzle (place numbers in a grid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.
